#include "config.h"
#include <iostream.h>
#include <stdlib.h>
#include <unistd.h>
#include "fdbuf.h"
#include "mystring.h"
#include "hostname.h"

fdibuf in(0);
fdobuf out(1);
const char* filename = 0;

int smtp_get(mystring& str)
{
  mystring tmp;
  str = "";
  int code = -1;
  while(in.getline(tmp)) {
    if(tmp[tmp.length()-1] == '\r')
      tmp = tmp.left(tmp.length()-1);
    code = atoi(tmp.c_str());
    if(!!str)
      str += "/";
    str += tmp.right(4);
    if(tmp[3] != '-')
      break;
  }
  return code;
}

int smtp_put(mystring cmd, mystring& result)
{
  if(!out.write(cmd) ||
     !out.write("\r\n") ||
     !out.flush())
    return -1;
  return smtp_get(result);
}

void smtp_do(mystring cmd, int range)
{
  mystring msg;
  int code;
  if(!cmd)
    code = smtp_get(msg);
  else
    code = smtp_put(cmd, msg);
  if(code < range || code >= (range+100)) {
    cerr << filename << ": SMTP Error: " << code << ' ' << msg << endl;
    exit(1);
  }
}

bool send_envelope(fdibuf& msg)
{
  mystring tmp;
  msg.getline(tmp);
  smtp_do("MAIL FROM: <" + tmp + ">", 250);
  while(msg.getline(tmp) && !!tmp) {
    smtp_do("RCPT TO: <" + tmp + ">", 250);
  }
  return true;
}

bool send_data(fdibuf& msg)
{
  smtp_do("DATA", 354);
  mystring tmp;
  while(msg.getline(tmp)) {
    if(!out.write(tmp) ||
       !out.write("\r\n")) {
      cerr << filename << " SMTP error while writing message" << endl;
      return false;
    }
  }
  smtp_do(".", 250);
  return true;
}

int main(int argc, char* argv[])
{
  smtp_do("", 220);
  smtp_do("HELO " + hostname(), 250);
  for(int i = 1; i < argc; i++) {
    filename = argv[i];
    fdibuf msg(filename);
    if(!msg) {
      cerr << filename << " Could not open" << endl;
      return 1;
    }
    if(!send_envelope(msg) ||
       !send_data(msg))
      return 1;
    cerr << filename << " OK" << endl;
  }
  smtp_do("QUIT", 221);
  return 0;
}
